enum find_key_states {
	START,
	HEADER_FOUND,
	VERSION_FOUND,
	SUCCESS,
};

typedef struct {
	size_t len;
	char* data;
} byte_sequence;

typedef struct {
	byte_sequence* modulus;
	byte_sequence* E;
	byte_sequence* D;
	byte_sequence* P;
	byte_sequence* Q;
	byte_sequence* DP;
	byte_sequence* DQ;
	byte_sequence* IQ;
} private_key;

typedef int(*mem_read)(void);
typedef int(*mem_seek)(unsigned int addr);
typedef int(*mem_tell)(void);
typedef int(*mem_error)(void);

typedef struct {
	mem_read read;
	mem_seek seek;
	mem_tell tell;
	mem_error error;
} mem_access;

private_key* ssl_find_private_key(mem_access* memory);
